#ifndef _PORTABILITY_H_
#define _PORTABILITY_H_

#ifdef _MSC_VER
#ifdef _M_IX86

/* rint doesn't seem to exist for MSVC */

inline double rint ( const double x )
{
  double y ;

  _asm
  {
    fld x
    frndint
    fstp y
    fwait
  }

  return y ;
}
#endif
#endif


/* M_PI doesn't exist for MSVC */

#ifndef M_PI
#  define M_PI 3.14159265
#endif


#if defined( WIN32)
#include <stdio.h>
#ifdef __cplusplus
extern "C" {
#endif
        int vsnprintf(char* str, size_t size, const char* fmt, va_list ap);
        int snprintf(char* str, size_t size, const char* fmt, ...);
#ifdef __cplusplus
}
#endif
#endif

#ifdef _MSC_VER
#define HAVE_BOOL
#    pragma warning(disable: 4786) // identifier was truncated to '255' characters
#    pragma warning(disable: 4244) // conversion from double to float
#    pragma warning(disable: 4305) //
#endif

#ifndef HAVE_BOOL
#define HAVE_BOOL
typedef int bool;
const bool false = 0;
const bool true = 1;
#endif

#endif

