
#include "BoD.h"

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <ctype.h>

#ifndef TRUE
#define TRUE 1
#define FALSE 0
#endif

#define INSERT_STRING "% XXX INSERT XXX"


void printCheque ( int ncheques, int cheque_number,
                   char *name, char *line1, char *line2 )
{
  char *printer = getenv ( "BOD_PRINT_COMMAND" ) ;
  char  str [ 1024 ] ;

  if ( printer == NULL || printer[0] == '\0' )
    printer = "lpr" ;

  while ( ncheques-- > 0 )
  {
    FILE * in_fd = fopen ( "../images/BoDcheque.ps", "r" ) ;

    if ( in_fd == NULL )
    {
      fprintf ( stderr, "Failed to open BoDcheque.ps\n" ) ;
      exit ( 1 ) ;
    }

    FILE *out_fd = popen ( printer, "w" ) ;

    if ( out_fd == NULL )
    {
      fprintf ( stderr, "Failed to start printer command '%s'.\n",
                                        printer ) ;
      exit ( 1 ) ;
    }


    while ( fgets ( str, 1024, in_fd ) != NULL )
    {
      if ( strncmp ( str, INSERT_STRING, strlen(INSERT_STRING) ) == 0 )
      {
	fprintf ( out_fd, "372 238 moveto\n" ) ;
	fprintf ( out_fd, "/Helvetica findfont 15 scalefont setfont\n" ) ;
	fprintf ( out_fd, "(%4d) show\n", cheque_number++ ) ;
	fprintf ( out_fd, "108 241 moveto\n" ) ;

	int in_lower = FALSE ;
	fprintf ( out_fd, "/Times-Bold findfont 10 scalefont setfont\n" ) ;
	fprintf ( out_fd, "(" ) ;

	for ( int i = 0 ; i < strlen ( name ) ; i++ )
	{
	  if ( islower ( name [ i ] ) )
	  {
	    if ( ! in_lower )
	    {
	      fprintf ( out_fd, ") show\n" ) ;
	      fprintf ( out_fd, "/Times-Bold findfont 8 scalefont setfont\n" ) ;
	      fprintf ( out_fd, "(" ) ;
	      in_lower = TRUE ;
	    }
	  }
	  else
	  {
	    if ( in_lower )
	    {
	      fprintf ( out_fd, ") show\n" ) ;
	      fprintf ( out_fd, "/Times-Bold findfont 10 scalefont setfont\n" ) ;
	      fprintf ( out_fd, "(" ) ;
	      in_lower = FALSE ;
	    }
	  }
   
	  fprintf ( out_fd, "%c", toupper ( name [ i ] ) ) ;
	}

	fprintf ( out_fd, ") show\n" ) ;

	fprintf ( out_fd, "108 228 moveto\n" ) ;
	fprintf ( out_fd, "/Times-Italic findfont 10 scalefont setfont\n" ) ;
	fprintf ( out_fd, "(%s) show\n", line1 ) ;
	fprintf ( out_fd, "108 215 moveto\n" ) ;
	fprintf ( out_fd, "/Times-Italic findfont 10 scalefont setfont\n" ) ;
	fprintf ( out_fd, "(%s) show\n", line2 ) ;
      }
      else
	fprintf ( out_fd, "%s", str ) ;
    }

    fclose (  in_fd ) ;
    pclose ( out_fd ) ;
  }
}


